// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('app', ['ionic', 'app.controllers', 'app.routes', 'app.services', 'app.directives', 'ngCordova'])

.run(function($ionicPlatform, $cordovaSQLite, $rootScope) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    // se o banco não existe, cria ele aqui
    var db = $cordovaSQLite.openDB({name: 'ceitificator.db', iosDatabaseLocation: 'default'});
    $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS people(id INTEGER PRIMARY KEY AUTOINCREMENT, name TEXT NOT NULL, grr TEXT NOT NULL, email TEXT NOT NULL, UNIQUE (name, grr, email))");
    $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS events(id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, name TEXT NOT NULL, desc TEXT NOT NULL, date TEXT NOT NULL, place TEXT NOT NULL, hours TEXT NOT NULL, UNIQUE (name, desc, date, place, hours))");
    $cordovaSQLite.execute(db, "CREATE TABLE IF NOT EXISTS people_events(event_id, person_id, FOREIGN KEY(event_id) REFERENCES events(id), FOREIGN KEY(person_id) REFERENCES people(id), UNIQUE (person_id, event_id))");
  });
})
