angular.module('app.services', [])

.factory('BlankFactory', [function() {

}])

.service('BlankService', [function() {

}])

.service('EventsService', function($cordovaSQLite, $q) {
    return {
        getEvents: function() {
            // pega no banco todos os eventos e retorna
            var events = [];
            var db = $cordovaSQLite.openDB({name: 'ceitificator.db',
                                            iosDatabaseLocation: 'default'});
            $cordovaSQLite.execute(db, "SELECT * FROM events")
            .then(function(res) {
                for(var i = 0; i < res.rows.length; i++) {
                    events.push(res.rows.item(i));
                }
            }, function(err) {
                console.log(err);
            });
            return events;
        },
        addNewEvent: function(event) {
            // adiciona um novo evento no banco
            var db = $cordovaSQLite.openDB({name: 'ceitificator.db',
                                            iosDatabaseLocation: 'default'});
            var query = "INSERT INTO events (name, desc, date, place, hours) VALUES (?,?,?,?,?)";
            $cordovaSQLite.execute(db, query, [event.eventName,
                                               event.eventDesc,
                                               event.eventDate,
                                               event.eventPlace,
                                               event.eventHours])
            .then(function(res) {
                console.log("res: " + res);
            }, function(err) {
                    console.error(err);
            });
        },
        getEventById: function(eventId) {
            // dado um id, retorna a palestra com o mesmo id
            var dfd = $q.defer();
            var db = $cordovaSQLite.openDB({name: 'ceitificator.db',
                                            iosDatabaseLocation: 'default'});
            var query = "SELECT * FROM events WHERE id=\"" + eventId + "\"";
            $cordovaSQLite.execute(db, query)
            .then(function(res) {
                console.log(res.rows);
                dfd.resolve(res.rows.item(0));
            }, function(err) {
                console.log(err);
            });
            return dfd.promise;
        }
    }
})

.service('PeopleService', function($cordovaSQLite, $q) {
    return {
        getPeople: function(eventId) {
            // pega no banco todas as pessoas
            var people = [];
            var db = $cordovaSQLite.openDB({name: 'ceitificator.db',
                                            iosDatabaseLocation: 'default'});
            $cordovaSQLite.execute(db, "SELECT people.* FROM people, people_events WHERE people.id=people_events.person_id AND people_events.event_id=" + eventId)
            .then(function(res) {
                for(var i = 0; i < res.rows.length; i++) {
                    people.push(res.rows.item(i));
                }
            }, function(err) {
                console.log(err);
            });
            return people;
        },
        addPersonInEvent: function(person, eventId) {
            // procura a pessoa, se existir, insere direto na tabela people_events, se não existir, cria a pessoa primeiro
            var dfd = $q.defer();
            var db = $cordovaSQLite.openDB({name: 'ceitificator.db',
                                            iosDatabaseLocation: 'default'});
            var query = "SELECT * FROM people WHERE name=\"" + person.name +
                        "\"AND grr=\"" + person.grr + "\"AND email=\"" +
                        person.email + "\"";
            $cordovaSQLite.execute(db, query)
            .then(function(res) {
                if (res.rows.length == 0) {
                    console.log("pessoa não existe");
                    query = "INSERT INTO people (name, grr, email) VALUES (?,?,?)";
                    $cordovaSQLite.execute(db, query, [person.name,
                                                       person.grr,
                                                       person.email])
                    .then(function(res) {
                        console.log("id: " + res.insertId);
                        query = "INSERT INTO people_events (event_id, person_id) VALUES (?,?)";
                        $cordovaSQLite.execute(db, query, [eventId, res.insertId])
                        .then(function(res) {
                            console.log("inseriu em people_events");
                            dfd.resolve(res);
                        }, function(err) {
                            console.error(err);
                            dfd.resolve(err);
                        });
                    }, function(err) {
                        console.error(err);
                        dfd.resolve(err);
                    });
                }
                else{
                    console.log("pessoa já existe:" + res.rows.item(0));
                    console.log("id: " + res.rows.item(0).id);
                    query = "INSERT INTO people_events (event_id, person_id) VALUES (?,?)";
                    $cordovaSQLite.execute(db, query, [eventId, res.rows.item(0).id])
                    .then(function(res) {
                        console.log("inseriu em people_events");
                        dfd.resolve(res);
                    }, function(err) {
                        console.error(err);
                        dfd.resolve(err);
                    });
                }
            }, function(err) {
                console.error(err);
                dfd.resolve(err);
            });
            return dfd.promise;
        }
    }
});
